searchNodes=[{"doc":"Analyzer takes in a valid repo URL and coordinates the analysis, returning a simple JSON report. The URL can be one of &quot;https&quot;, &quot;http&quot;, or &quot;file&quot;. Note, that the latter scheme will only work an existing clone and won&#39;t remove the directory structure upon completion of analysis.","ref":"AnalyzerModule.html","title":"AnalyzerModule","type":"module"},{"doc":"","ref":"AnalyzerModule.html#analyze/2","title":"AnalyzerModule.analyze/2","type":"function"},{"doc":"analyze/3: returns the LowEndInsight report as JSON for multiple_repos. Takes in a &quot;list&quot; of urls, a source id for the calling client, and the start_time of analysis as an optional way to capture the time actually started at whatever the client is (e.g. an async API). Returns Map. Examples iex&gt; {:ok, report} = AnalyzerModule.analyze([&quot;https://github.com/kitplummer/xmpp4rails&quot;,&quot;https://github.com/kitplummer/lita-cron&quot;], &quot;iex&quot;) iex&gt; _count = report[:metadata][:repo_count] 2","ref":"AnalyzerModule.html#analyze/3","title":"AnalyzerModule.analyze/3","type":"function"},{"doc":"create_empty_report/3: takes in a uuid, list of urls, and a start time and produces the repo report object to be returned immediately by asynchronous requestors (e.g. LowEndInsight-Get HTTP endpoint)","ref":"AnalyzerModule.html#create_empty_report/3","title":"AnalyzerModule.create_empty_report/3","type":"function"},{"doc":"determine_risk_counts/1: takes in a full report of n-repo reports, and calculates the number or risk ratings, given the number of repos. It returns a new report with the risk_counts object populated with the count table. Have to accommodate both the atom and string elements, becuse the JSON gets parsed into the string format - so caching can be supported (as reports are stored in JSON).","ref":"AnalyzerModule.html#determine_risk_counts/1","title":"AnalyzerModule.determine_risk_counts/1","type":"function"},{"doc":"determine_toplevel_risk/1: takes in a report and determines the highest criticality, and assigns it to the &quot;risk&quot; element for the repo report.","ref":"AnalyzerModule.html#determine_toplevel_risk/1","title":"AnalyzerModule.determine_toplevel_risk/1","type":"function"},{"doc":"","ref":"Data.html","title":"Data","type":"module"},{"doc":"Collection of lower-level functions for analyzing outputs from git command.","ref":"GitHelper.html","title":"GitHelper","type":"module"},{"doc":"get_avg_tag_commit_tim_diff/1: return the average time between commits within each subarray representing a tag","ref":"GitHelper.html#get_avg_tag_commit_time_diff/1","title":"GitHelper.get_avg_tag_commit_time_diff/1","type":"function"},{"doc":"get_contributor_counts/1: Gets the number of contributions belonging to each author and return a map of %{name =&gt; number}","ref":"GitHelper.html#get_contributor_counts/1","title":"GitHelper.get_contributor_counts/1","type":"function"},{"doc":"det_filtered_contributor_count/2: Gets the resolved list of contributers, return count and list","ref":"GitHelper.html#get_filtered_contributor_count/2","title":"GitHelper.get_filtered_contributor_count/2","type":"function"},{"doc":"get_total_tag_commit_time_diff/1: return the total time between commits within each subarray representing a tag","ref":"GitHelper.html#get_total_tag_commit_time_diff/1","title":"GitHelper.get_total_tag_commit_time_diff/1","type":"function"},{"doc":"parse_diff/1: returns the relevant information contained in the last array position of a diff array","ref":"GitHelper.html#parse_diff/1","title":"GitHelper.parse_diff/1","type":"function"},{"doc":"split_commits_by_tag/1: returns a list with sublists arranged by tag","ref":"GitHelper.html#split_commits_by_tag/1","title":"GitHelper.split_commits_by_tag/1","type":"function"},{"doc":"Collections of functions for interacting with the git command to perform queries.","ref":"GitModule.html","title":"GitModule","type":"module"},{"doc":"clone_repo/2: clones the repo","ref":"GitModule.html#clone_repo/2","title":"GitModule.clone_repo/2","type":"function"},{"doc":"","ref":"GitModule.html#delete_repo/1","title":"GitModule.delete_repo/1","type":"function"},{"doc":"get_commit_dates/1: returns a list of unix timestamps representing commit times","ref":"GitModule.html#get_commit_dates/1","title":"GitModule.get_commit_dates/1","type":"function"},{"doc":"get_contributions_map/1: returns a map of contributions per git user note: this map is unfiltered, dupes aren&#39;t identified","ref":"GitModule.html#get_contributions_map/1","title":"GitModule.get_contributions_map/1","type":"function"},{"doc":"get_contributors_count/1: returns the number of contributors for a given Git repo","ref":"GitModule.html#get_contributor_count/1","title":"GitModule.get_contributor_count/1","type":"function"},{"doc":"","ref":"GitModule.html#get_contributor_distribution/1","title":"GitModule.get_contributor_distribution/1","type":"function"},{"doc":"get_last_n_commits/2: returns a list of lines generated from the diff of two commits","ref":"GitModule.html#get_diff_2_commits/2","title":"GitModule.get_diff_2_commits/2","type":"function"},{"doc":"","ref":"GitModule.html#get_functional_contributors/1","title":"GitModule.get_functional_contributors/1","type":"function"},{"doc":"get_last_2_delta/1: returns the lines changed, files changed, additions and deletions in the last commit","ref":"GitModule.html#get_last_2_delta/1","title":"GitModule.get_last_2_delta/1","type":"function"},{"doc":"get_last_commit_date/1: returns the date of the last commit","ref":"GitModule.html#get_last_commit_date/1","title":"GitModule.get_last_commit_date/1","type":"function"},{"doc":"get_last_n_commits/1: returns a list of the short hashes of the last n commits","ref":"GitModule.html#get_last_n_commits/2","title":"GitModule.get_last_n_commits/2","type":"function"},{"doc":"get_recent_changes/1: returns the fraction of changed lines in the last commit by the total lines in the repo","ref":"GitModule.html#get_recent_changes/1","title":"GitModule.get_recent_changes/1","type":"function"},{"doc":"get_repo/1: gets a repo by path, returns Repository struct","ref":"GitModule.html#get_repo/1","title":"GitModule.get_repo/1","type":"function"},{"doc":"get_tag_and_commit_dates/1: returns a list of lists of unix timestamps representing commit times with each lsit belonging to a different tag","ref":"GitModule.html#get_tag_and_commit_dates/1","title":"GitModule.get_tag_and_commit_dates/1","type":"function"},{"doc":"","ref":"GitModule.html#get_top10_contributors_map/1","title":"GitModule.get_top10_contributors_map/1","type":"function"},{"doc":"get_total_lines/1: returns the total lines and files contained in a repo as of the latest commit","ref":"GitModule.html#get_total_lines/1","title":"GitModule.get_total_lines/1","type":"function"},{"doc":"Collection of generic helper functions.","ref":"Helpers.html","title":"Helpers","type":"module"},{"doc":"convert_config_to_list/1: takes in Application.get_all_env(:app) and returns a list of maps, to be encoded as JSON. Since JSON doesn&#39;t have an equivalent tuple type the libs all bonk on encoding config values.","ref":"Helpers.html#convert_config_to_list/1","title":"Helpers.convert_config_to_list/1","type":"function"},{"doc":"","ref":"Helpers.html#count_forward_slashes/1","title":"Helpers.count_forward_slashes/1","type":"function"},{"doc":"get_slug/1: extracts the slug from the provided URI argument and returns the path Example iex(1)&gt; {:ok, slug} = Helpers.get_slug(&quot;https://github.com/kitplummer/xmpprails&quot;) {:ok, &quot;kitplummer/xmpprails&quot;} iex(2)&gt; slug &quot;kitplummer/xmpprails&quot;","ref":"Helpers.html#get_slug/1","title":"Helpers.get_slug/1","type":"function"},{"doc":"split_slug/1: splits apart the username and repo from a git slug returning discrete stings. Examples iex(6)&gt; {:ok, org, repo} = Helpers.split_slug(&quot;kitplummer/xmpprails&quot;) {:ok, &quot;kitplummer&quot;, &quot;xmpprails&quot;} iex(7)&gt; org &quot;kitplummer&quot; iex(8)&gt; repo &quot;xmpprails&quot;","ref":"Helpers.html#split_slug/1","title":"Helpers.split_slug/1","type":"function"},{"doc":"validates field is a valid url Examples iex&gt; &quot;https:://www.url.com&quot; ...&gt; |&gt; Helpers.validate_url() iex&gt; &quot;http://zipbooks.com/&quot; ...&gt; |&gt; Helpers.validate_url() :ok iex&gt; &#39;&quot;https://\"https://www.google.com&quot;&#39; ...&gt; |&gt; Helpers.validate_url() iex&gt; &quot;zipbooks.com&quot; ...&gt; |&gt; Helpers.validate_url() iex&gt; &quot;https://zipbooks..com&quot; ...&gt; |&gt; Helpers.validate_url()","ref":"Helpers.html#validate_url/1","title":"Helpers.validate_url/1","type":"function"},{"doc":"iex&gt; [&quot;http://www.google.com\",\"http://www.test.com&quot;] ...&gt; |&gt; Helpers.validate_urls() :ok iex&gt; [&quot;https://zipbooks..com&quot;, &quot;http://www.test.com&quot;] ...&gt; |&gt; Helpers.validate_urls() iex&gt; [&quot;https//github.com/kitplummer/xmpp4rails&quot;,&quot;https://www.zipbooks.com&quot;, &quot;http://www.test.com&quot;] ...&gt; |&gt; Helpers.validate_urls() iex&gt; &quot;https://zipbooks.com&quot; ...&gt; |&gt; Helpers.validate_urls()","ref":"Helpers.html#validate_urls/1","title":"Helpers.validate_urls/1","type":"function"},{"doc":"This is used to run a LowEndInsight scan against a repository, by cloning it locally, then looking into it. Pass in the repo URL as a parameter to the task. #Usage mix analyze &quot;https://github.com/kitplummer/xmpp4rails&quot; | jq This will return a basic report (prettied by jq) as an Elixir Map. { &quot;data&quot;: { &quot;commit_currency_risk&quot;: &quot;critical&quot;, &quot;commit_currency_weeks&quot;: 563, &quot;contributor_count&quot;: 1, &quot;contributor_risk&quot;: &quot;critical&quot;, &quot;functional_contributor_names&quot;: [ &quot;Kit Plummer&quot; ], &quot;functional_contributors&quot;: 1, &quot;functional_contributors_risk&quot;: &quot;critical&quot;, &quot;large_recent_commit_risk&quot;: &quot;low&quot;, &quot;recent_commit_size_in_percent_of_codebase&quot;: 0.003683241252302026, &quot;repo&quot;: [ &quot;https://github.com/kitplummer/xmpp4rails&quot; ], &quot;risk&quot;: &quot;critical&quot; }, &quot;header&quot;: { &quot;duration&quot;: 1, &quot;end_time&quot;: &quot;2019-10-24 16:21:56.252768Z&quot;, &quot;source_client&quot;: &quot;mix task&quot;, &quot;start_time&quot;: &quot;2019-10-24 16:21:55.692010Z&quot;, &quot;uuid&quot;: &quot;659b37a2-f67a-11e9-ab5d-88e9fe666193&quot; } }","ref":"Mix.Tasks.Analyze.html","title":"Mix.Tasks.Analyze","type":"task"},{"doc":"Callback implementation for Mix.Task.run/1.","ref":"Mix.Tasks.Analyze.html#run/1","title":"Mix.Tasks.Analyze.run/1","type":"function"},{"doc":"","ref":"ProjectIdent.html","title":"ProjectIdent","type":"module"},{"doc":"is_cargo?/1: takes in a Repository struct and returns true if there is presence of a Cargo.toml file.","ref":"ProjectIdent.html#is_cargo?/1","title":"ProjectIdent.is_cargo?/1","type":"function"},{"doc":"is_go_mod?/1: takes in a Repository struct and returns true if there is presence of a go.mod file.","ref":"ProjectIdent.html#is_go_mod?/1","title":"ProjectIdent.is_go_mod?/1","type":"function"},{"doc":"is_gradle?/1: takes in a Repository struct and returns true if there is presence of a build.gradle file.","ref":"ProjectIdent.html#is_gradle?/1","title":"ProjectIdent.is_gradle?/1","type":"function"},{"doc":"is_maven?/1: takes in a Repository struct and returns true if there is presence of a pom.xml","ref":"ProjectIdent.html#is_maven?/1","title":"ProjectIdent.is_maven?/1","type":"function"},{"doc":"is_mix?/1: takes in a Repository struct and returns true if the repo has a mix.exs file. NOTE: mix will install dependencies into deps/ so we&#39;re gonna ignore those, and only recognize the mix.exs/mix.lock at the root directory","ref":"ProjectIdent.html#is_mix?/1","title":"ProjectIdent.is_mix?/1","type":"function"},{"doc":"is_node?/1: takes in a Repository struct and returns true if there is presence of a package.json file. NOTE: this could be a yarn or npm project.","ref":"ProjectIdent.html#is_node?/1","title":"ProjectIdent.is_node?/1","type":"function"},{"doc":"is_python?/1: takes in a Repository struct and returns true if there is the presence of a setup.py or *requirements.txt file. NOTE: this could be either a pip or conda project.","ref":"ProjectIdent.html#is_python?/1","title":"ProjectIdent.is_python?/1","type":"function"},{"doc":"is_rubygem?/1: takes in a Repository struct and returns true if there is presence of a Gemfile file.","ref":"ProjectIdent.html#is_rubygem?/1","title":"ProjectIdent.is_rubygem?/1","type":"function"},{"doc":"project_types?/1: takes in a Repository and will return a list of found project types within the repo.","ref":"ProjectIdent.html#project_types?/1","title":"ProjectIdent.project_types?/1","type":"function"},{"doc":"","ref":"RepoReport.html","title":"RepoReport","type":"module"},{"doc":"","ref":"Results.html","title":"Results","type":"module"},{"doc":"RiskLogic contains the functionality for determining risk based on numeric input values","ref":"RiskLogic.html","title":"RiskLogic","type":"module"},{"doc":"last_commit_size_risk/1: returns a text enumeration for the risk based on the size of the last commit","ref":"RiskLogic.html#commit_change_size_risk/1","title":"RiskLogic.commit_change_size_risk/1","type":"function"},{"doc":"commit_currency_risk/1: returns text enumeration for commit currency risk","ref":"RiskLogic.html#commit_currency_risk/1","title":"RiskLogic.commit_currency_risk/1","type":"function"},{"doc":"contributor_risk/1: returns text enumeration for count","ref":"RiskLogic.html#contributor_risk/1","title":"RiskLogic.contributor_risk/1","type":"function"},{"doc":"functional_contributors_risk/1: returns the enumerated risk based on input contributors list","ref":"RiskLogic.html#functional_contributors_risk/1","title":"RiskLogic.functional_contributors_risk/1","type":"function"},{"doc":"Collection of functions for handling time-based conversions.","ref":"TimeHelper.html","title":"TimeHelper","type":"module"},{"doc":"get_commit_delta/1: returns the time between now and the last commit in seconds","ref":"TimeHelper.html#get_commit_delta/1","title":"TimeHelper.get_commit_delta/1","type":"function"},{"doc":"sec_to_days/1: returns a roll-up of days from a number of secs","ref":"TimeHelper.html#sec_to_days/1","title":"TimeHelper.sec_to_days/1","type":"function"},{"doc":"sec_to_str/1: returns a string breakdown of total seconds into weeks, days, hours, minutes and remaining seconds. Examples iex&gt; TimeHelper.sec_to_str(5211) &quot;1 hr, 26 min, 51 sec&quot;","ref":"TimeHelper.html#sec_to_str/1","title":"TimeHelper.sec_to_str/1","type":"function"},{"doc":"sec_to_weeks/1: returns a roll-up of weeks from a number of secs","ref":"TimeHelper.html#sec_to_weeks/1","title":"TimeHelper.sec_to_weeks/1","type":"function"},{"doc":"sum_ts_diff/1","ref":"TimeHelper.html#sum_ts_diff/1","title":"TimeHelper.sum_ts_diff/1","type":"function"},{"doc":"sum_ts_diff/2","ref":"TimeHelper.html#sum_ts_diff/2","title":"TimeHelper.sum_ts_diff/2","type":"function"},{"doc":"LowEndInsight LowEndInsight is a simple &quot;bus-factor&quot; risk analysis library for Open Source Software which is managed within a Git repository. Provide the git URL and the library will respond with a basic Elixir Map structure report. If you are at all concerned about risks associated with upstream dependency requirements LowEndInsight can provide valuable, and actionable information around the likelihood of critical issues being resolved, if ever reported. For example, a repo with a single contributor isn&#39;t necessarily bad, but it should be considered with some level of risk. Are you or your organization willing to assume ownership (fork) of the repository to resolve issues yourself? Or if there hasn&#39;t been a commit against the source repository, in some significant amount of time, can you assume that it is inactive, or just stable? Again, the intent of LowEndInsight isn&#39;t to say that any upstream Open Source dependency is bad, just that the risks should be smartly weighed, and a deeper understanding of the implications should be gained during the decision to use. LowEndInsight provides a simple mechanism for investigating and applying basic governance (based on your definition of the tolerance level) and responds with a useful report for integrating into your existing automation. Or you can easily use LowEndInsight as an ad-hoc reporting tool, running it manually. ✗ mix analyze https://github.com/facebook/react | jq { &quot;state&quot;: &quot;complete&quot;, &quot;report&quot;: { &quot;uuid&quot;: &quot;96b516a0-5660-11ea-a1fa-784f434ce29a&quot;, &quot;repos&quot;: [ { &quot;header&quot;: { &quot;uuid&quot;: &quot;96b4e202-5660-11ea-81d3-784f434ce29a&quot;, &quot;start_time&quot;: &quot;2020-02-23T17:18:38.532966Z&quot;, &quot;source_client&quot;: &quot;mix task&quot;, &quot;library_version&quot;: &quot;&quot;, &quot;end_time&quot;: &quot;2020-02-23T17:19:03.321647Z&quot;, &quot;duration&quot;: 25 }, &quot;data&quot;: { &quot;risk&quot;: &quot;low&quot;, &quot;results&quot;: { &quot;top10_contributors&quot;: [ { &quot;Paul O’Shannessy&quot;: 1777 }, { &quot;Dan Abramov&quot;: 1351 }, { &quot;Brian Vaughn&quot;: 1326 }, { &quot;Sophie Alpert&quot;: 1265 }, { &quot;Sebastian Markbåge&quot;: 753 }, { &quot;Andrew Clark&quot;: 691 }, { &quot;Jim Sproch&quot;: 456 }, { &quot;Pete Hunt&quot;: 332 }, { &quot;Dominic Gannaway&quot;: 319 }, { &quot;Cheng Lou&quot;: 222 } ], &quot;recent_commit_size_in_percent_of_codebase&quot;: 1.4611978900302468e-05, &quot;large_recent_commit_risk&quot;: &quot;low&quot;, &quot;functional_contributors_risk&quot;: &quot;low&quot;, &quot;functional_contributors&quot;: 83, &quot;functional_contributor_names&quot;: [ &quot;yiminghe&quot;, &quot;Marshall Roch&quot;, &quot;Flarnie Marchan&quot;, &quot;Daniel Lo Nigro&quot;, &quot;Philipp Spieß&quot;, &quot;Edvin Erikson&quot;, &quot;Mateusz Burzyński&quot;, &quot;Pete Hunt&quot;, ... ], &quot;contributor_risk&quot;: &quot;low&quot;, &quot;contributor_count&quot;: 1488, &quot;commit_currency_weeks&quot;: 0, &quot;commit_currency_risk&quot;: &quot;low&quot; }, &quot;repo&quot;: &quot;https://github.com/facebook/react&quot;, &quot;project_types&quot;: { &quot;node&quot;: [ &quot;/var/folders/lm/dv8hd46901j00z5mj97jsj9r0000gn/T/lei-1582478318-32287-14ntgii/react/fixtures/art/package.json&quot;, &quot;/var/folders/lm/dv8hd46901j00z5mj97jsj9r0000gn/T/lei-1582478318-32287-14ntgii/react/fixtures/attribute-behavior/package.json&quot;, &quot;/var/folders/lm/dv8hd46901j00z5mj97jsj9r0000gn/T/lei-1582478318-32287-14ntgii/react/fixtures/concurrent/time-slicing/package.json&quot;, &quot;/var/folders/lm/dv8hd46901j00z5mj97jsj9r0000gn/T/lei-1582478318-32287-14ntgii/react/fixtures/dom/package.json&quot;, &quot;/var/folders/lm/dv8hd46901j00z5mj97jsj9r0000gn/T/lei-1582478318-32287-14ntgii/react/fixtures/eslint/package.json&quot;, ... ] }, &quot;config&quot;: { &quot;medium_large_commit_level&quot;: 0.05, &quot;medium_functional_contributors_level&quot;: 5, &quot;medium_currency_level&quot;: 26, &quot;medium_contributor_level&quot;: 5, &quot;high_large_commit_level&quot;: 0.15, &quot;high_functional_contributors_level&quot;: 3, &quot;high_currency_level&quot;: 52, &quot;high_contributor_level&quot;: 3, &quot;critical_large_commit_level&quot;: 0.3, &quot;critical_functional_contributors_level&quot;: 2, &quot;critical_currency_level&quot;: 104, &quot;critical_contributor_level&quot;: 2 } } } ] }, &quot;metadata&quot;: { &quot;times&quot;: { &quot;start_time&quot;: &quot;2020-02-23T17:18:38.523771Z&quot;, &quot;end_time&quot;: &quot;2020-02-23T17:19:03.352096Z&quot;, &quot;duration&quot;: 25 }, &quot;risk_counts&quot;: { &quot;low&quot;: 1 }, &quot;repo_count&quot;: 1 } } NOTE: that the &quot;file://&quot; is also supporting, but presumes that the directory provided is a valid Git clone. Analysis of a file://-based repo will not conclude with the directory structure being removed.","ref":"readme.html","title":"LowEndInsight","type":"extras"},{"doc":"LowEndInsight available in Hex, the package can be installed by adding lowendinsight to your list of dependencies in mix.exs: def deps do [ {:lowendinsight, &quot;~&gt; 0.4&quot;} ] end NOTE: check hex.pm for the latest version.","ref":"readme.html#installation","title":"LowEndInsight - Installation","type":"extras"},{"doc":"You either need to have Elixir and Erlang installed locally or possibly a container to run stuff in. REPL iex -S mix This will get you the iex prompt: Interactive Elixir (1.9.4) - press Ctrl+C to exit (type h() ENTER for help) iex(1)&gt; AnalyzerModule.analyze &quot;https://github.com/kitplummer/xmpp4rails&quot;, &quot;iex&quot; {:ok, %{ data: %{ commit_currency_risk: &quot;critical&quot;, commit_currency_weeks: 573, config: [ high_contributor_level: 3, medium_currency_level: 26, medium_contributor_level: 5, medium_large_commit_level: 0.05, critical_large_commit_level: 0.3, medium_functional_contributors_level: 5, critical_functional_contributors_level: 2, high_functional_contributors_level: 3, high_large_commit_level: 0.15, critical_currency_level: 104, critical_contributor_level: 2, high_currency_level: 52 ], contributor_count: 1, contributor_risk: &quot;critical&quot;, functional_contributor_names: [&quot;Kit Plummer&quot;], functional_contributors: 1, functional_contributors_risk: &quot;critical&quot;, large_recent_commit_risk: &quot;low&quot;, recent_commit_size_in_percent_of_codebase: 0.003683241252302026, repo: &quot;https://github.com/kitplummer/xmpp4rails&quot;, risk: &quot;critical&quot; }, header: %{ duration: 0, end_time: &quot;2020-01-08T01:51:54.633837Z&quot;, library_version: &quot;&quot;, source_client: &quot;iex&quot;, start_time: &quot;2020-01-08T01:51:54.069485Z&quot;, uuid: &quot;726a728e-31b9-11ea-bfa9-784f434ce29a&quot; } }} Here&#39;s the command that you would paste in to the iex REPL as an example: AnalyzerModule.analyze &quot;https://github.com/kitplummer/xmpp4rails&quot;, &quot;iex&quot; Docker You can pass in this lib and configuration settings, into a base Elixir container. From the root directory of a clone of this repo run this: docker run --rm -v $PWD:/app -w /app -it -e LEI_CRITICAL_CURRENCY_LEVEL=60 elixir:latest bash -c &quot;mix local.hex;mix deps.get;iex -S mix&quot; From iex you can access to the library functions. Erlang/OTP 22 [erts-10.6.3] [source] [64-bit] [smp:4:4] [ds:4:4:10] [async-threads:1] [hipe] [dtrace] Interactive Elixir (1.10.0) - press Ctrl+C to exit (type h() ENTER for help) iex(1)&gt; AnalyzerModule.analyze([&quot;https://github.com/kitplummer/xmpp4rails&quot;], &quot;iex&quot;) {:ok, %{ metadata: %{ repo_count: 1, risk_counts: %{&quot;critical&quot; =&gt; 1}, times: %{ duration: 1, end_time: &quot;2020-02-08T04:35:35.109053Z&quot;, start_time: &quot;2020-02-08T04:35:34.078971Z&quot; } }, report: %{ repos: [ %{ ... } Mix There is also an Elixir mix task that you can use to access the AnalyzeModule.analyze(url, client) function. So if have this repo cloned: mix analyze https://github.com/kitplummer/xmpp4rails | jq This will return: { &quot;state&quot;: &quot;complete&quot;, &quot;report&quot;: { &quot;uuid&quot;: &quot;86ac4538-4a28-11ea-897f-82dd17abe001&quot;, &quot;repos&quot;: [ { &quot;header&quot;: { &quot;uuid&quot;: &quot;86ac38f4-4a28-11ea-89c1-82dd17abe001&quot;, &quot;start_time&quot;: &quot;2020-02-08T04:07:29.736126Z&quot;, &quot;source_client&quot;: &quot;mix task&quot;, ... } LowEndInsight REST-y API Also, there is a sister project that wraps this library and provides an HTTP-based interface. https://github.com/gtri/lowendinsight-get","ref":"readme.html#running","title":"LowEndInsight - Running","type":"extras"},{"doc":"API available at: https://hexdocs.pm/lowendinsight/readme.html#content This is the library piece of the puzzle. As mentioned above there is an HTTP API available as well. The library is written in Elixir. mix docs will generate static docs available locally within the repo&#39;s root, in the docs/ subdirectory. JSON Schema LowEndInsight makes available the API&#39;s schema in JSON form, which can be found in the schema/ subdirectory. In addition, the schema docs are available in schema/docs as Markdown. A Note about the metrics used Recent commit size: This is a measure of how large the most recent commit is in relatino to the size of the codebase. The idea being that a large recent commit is much more likely to be bug filled than a relatively small commit. Functional Contributors: A functional contributor is one that contributes above a certain percentage of commits equal to or greater than their &quot;fair&quot; share. Simply put, a contributor is counted as a functional contributor if the proportion of their commits to the total commits is greater than or equal to 1 / the total number of committers. If everyone committed the same amount, everyone would be a functional contributor. risk is a top-level key that contains the &quot;rolled up&quot; risk, the highest value pulled from any of the discrete analysis items. Configuration LowEndInsight allows for customization of the risk levels, to determine &quot;low&quot;, &quot;medium&quot;, &quot;high&quot; and &quot;critical&quot; acceptance. The library reads this configuration from config.exs (or dev|test|prod.exs) as seen here, or as providing in environment variables. ## Contributor in terms of discrete users ## NOTE: this currently doesn&#39;t discern same user with different email critical_contributor_level: String.to_integer(System.get_env(&quot;LEI_CRITICAL_CONTRIBUTOR_LEVEL&quot;) || &quot;2&quot;), high_contributor_level: System.get_env(&quot;LEI_HIGH_CONTRIBUTOR_LEVEL&quot;) || 3, medium_contributor_level: System.get_env(&quot;LEI_CRITICAL_CONTRIBUTOR_LEVEL&quot;) || 5, ## Commit currency in weeks - is the project active. This by itself ## may not indicate anything other than the repo is stable. The reason ## we&#39;re reporting it is relative to the likelihood vulnerabilities ## getting fix in a timely manner critical_currency_level: String.to_integer(System.get_env(&quot;LEI_CRITICAL_CURRENCY_LEVEL&quot;) || &quot;104&quot;), high_currency_level: String.to_integer(System.get_env(&quot;LEI_HIGH_CURRENCY_LEVEL&quot;) || &quot;52&quot;), medium_currency_level: String.to_integer(System.get_env(&quot;LEI_MEDIUM_CURRENCY_LEVEL&quot;) || &quot;26&quot;), ## Percentage of changes to repo in recent commit - is the codebase ## volatile in terms of quantity of source being changed critical_large_commit_level: String.to_float(System.get_env(&quot;LEI_CRITICAL_LARGE_COMMIT_LEVEL&quot;) || &quot;0.30&quot;), high_large_commit_level: String.to_float(System.get_env(&quot;LEI_HIGH_LARGE_COMMIT_LEVEL&quot;) || &quot;0.15&quot;), medium_large_commit_level: String.to_float(System.get_env(&quot;LEI_MEDIUM_LARGE_COMMIT_LEVEL&quot;) || &quot;0.05&quot;), ## Bell curve contributions - if there are 30 contributors ## but 90% of the contributions are from 2... critical_functional_contributors_level: String.to_integer(System.get_env(&quot;LEI_CRITICAL_FUNCTIONAL_CONTRIBUTORS_LEVEL&quot;) || &quot;2&quot;), high_functional_contributors_level: String.to_integer(System.get_env(&quot;LEI_HIGH_FUNCTIONAL_CONTRIBUTORS_LEVEL&quot;) || &quot;3&quot;), medium_functional_contributors_level: String.to_integer(System.get_env(&quot;LEI_MEDIUM_FUNCTIONAL_CONTRIBUTORS_LEVEL&quot;) || &quot;5&quot;) To override with an environment variable you just need to have it set: LEI_CRITICAL_CURRENCY_PAR_LEVEL=60 mix analyze https://github.com/kitplummer/xmpp4rails If you receive an error in the report with the following (or similar missing environment configuration variable) - the required configuration for LowEndInsight hasn&#39;t been made available: could not fetch application environment :critical_contributor_level for application :lowendinsight because the application was not loaded/started. If your application depends on :lowendinsight at runtime, make sure to load/start it or list it under :extra_applications in your mix.exs file","ref":"readme.html#docs","title":"LowEndInsight - Docs","type":"extras"},{"doc":"Thanks for considering, we need your contributions to help this project come to fruition. Here are some important resources: Bugs? Issues is where to report them Style The repo includes auto-formatting, please run mix format to format to the standard style prescribed by the Elixir project: https://hexdocs.pm/mix/Mix.Tasks.Format.html https://github.com/christopheradams/elixir_style_guide Code docs for functions are expected. Examples are a bonus: https://hexdocs.pm/elixir/writing-documentation.html Testing Required. Please write ExUnit test for new code you create. Use mix test --cover to verify that you&#39;re maintaining coverage. Github Actions Just getting this built-out. But the bitbucket-pipeline config is still here too. Submitting changes Please send a Pull Request with a clear list of what you&#39;ve done and why. Please follow Elixir coding conventions (above in Style) and make sure all of your commits are atomic (one feature per commit). Always write a clear log message for your commits. One-line messages are fine for small changes, but bigger changes should look like this: $ git commit -m &quot;A brief summary of the commit &gt; &gt; A paragraph describing what changed and its impact.&quot; JSON Schema The JSON schema found in schema is and should be used to validate the main analysis interfaces&#39; input and expected outputs. Any modifications in implementations should also be made to the schemas and verified/validated by tests. There is an external tool used to do the schema docs conversion: jsonschema2md -d schemas/ -o schema/docs. If you make a modification to the schema please run the tool to update the docs with the submission.","ref":"readme.html#contributing","title":"LowEndInsight - Contributing","type":"extras"},{"doc":"BSD 3-Clause. See https://opensource.org/licenses/BSD-3-Clause or LICENSE file for details.","ref":"readme.html#license","title":"LowEndInsight - License","type":"extras"}]